package com.chrismweb.box2dforflashgames 
{
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Dynamics.Contacts.*;
	
	/**
	 * ...
	 * @author Ackmi
	 */
	public class CustomContact extends b2ContactListener 
	{
		public var output_text:String = "";
		public function CustomContact() 
		{			
		}
		override public function BeginContact(contact:b2Contact):void
		{
			output_text=("a collision started");
			var fixtureA:b2Fixture=contact.GetFixtureA();
			var fixtureB:b2Fixture=contact.GetFixtureB();
			var bodyA:b2Body=fixtureA.GetBody();
			var bodyB:b2Body=fixtureB.GetBody();
			output_text+=("first body: "+bodyA.GetUserData());
			output_text+='\n'+("second body: "+bodyB.GetUserData());
			output_text+='\n'+("---------------------------");
		}
		override public function EndContact(contact:b2Contact):void
		{
			output_text+='\n'+("a collision ended");
			var fixtureA:b2Fixture=contact.GetFixtureA();
			var fixtureB:b2Fixture=contact.GetFixtureB();
			var bodyA:b2Body=fixtureA.GetBody();
			var bodyB:b2Body = fixtureB.GetBody();
			output_text+='\n'+("first body: "+bodyA.GetUserData());
			output_text+='\n'+("second body: "+bodyB.GetUserData());
			output_text+='\n'+("---------------------------");
		}
		override public function PreSolve(contact:b2Contact, oldManifold:b2Manifold):void 
		{
			if (contact.GetManifold().m_pointCount > 0) 
			{
				output_text+='\n'+("a collision has been pre solved");
				var fixtureA:b2Fixture=contact.GetFixtureA();
				var fixtureB:b2Fixture=contact.GetFixtureB();
				var bodyA:b2Body=fixtureA.GetBody();
				var bodyB:b2Body=fixtureB.GetBody();
				output_text+='\n'+("first body: "+bodyA.GetUserData());
				output_text+='\n'+("second body: "+bodyB.GetUserData());
				output_text+='\n'+("---------------------------");
			}
		}
		override public function PostSolve(contact:b2Contact, impulse:b2ContactImpulse):void 
		{
			output_text+='\n'+("a collision has been post solved");
			var fixtureA:b2Fixture=contact.GetFixtureA();
			var fixtureB:b2Fixture=contact.GetFixtureB();
			var bodyA:b2Body=fixtureA.GetBody();
			var bodyB:b2Body=fixtureB.GetBody();
			output_text+='\n'+("first body: "+bodyA.GetUserData());
			output_text+='\n'+("second body: "+bodyB.GetUserData());
			output_text+='\n'+("impulse: "+impulse.normalImpulses[0]);
			output_text+='\n'+("---------------------------");
		}

		
		
		
	}

}